Merge pull request #1870 from saper/langinfo_h
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = assemblyresolve gc-descriptors
2
3 check-local: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test-cattr-type-load test-reflection-load-with-context test_platform test-process-exit test-messages test-unhandled-exception-2 rm-empty-logs
4 check-full: test-sgen check-local
5 check-parallel: compile-tests check-full
6
7 # for backwards compatibility on Wrench
8 test-wrench: check-parallel
9
10 aotcheck: testaot gshared-aot
11
12 TEST_PROG = ../interpreter/mint
13
14 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
15
16 TEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
17 JITTEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
18
19 RUNTIME_ARGS=--config tests-config --optimize=all --debug
20
21 CLASS=$(mcs_topdir)/class/lib/$(DEFAULT_PROFILE)
22
23 with_mono_path = MONO_PATH=$(CLASS)
24
25 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
26
27 MKBUNDLE = \
28         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
29         $(RUNTIME) $(CLASS)/mkbundle.exe
30
31 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -debug \
32         -nowarn:0162 -nowarn:0168 -nowarn:0219 -nowarn:0414 -nowarn:0618 \
33         -nowarn:0169 -nowarn:1690 -nowarn:0649 -nowarn:0612 -nowarn:3021 \
34         -nowarn:0197
35 ILASM = $(RUNTIME) $(CLASS)/ilasm.exe
36
37 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
38
39 STRESS_TESTS_SRC=       \
40         abort-stress-1.cs       \
41         abort-stress-2.cs       \
42         abort-stress-3.cs       \
43         domain-stress.cs        \
44         gchandle-stress.cs      \
45         monitor-stress.cs       \
46         thread-stress.cs        \
47         gc-stress.cs            \
48         gc-copy-stress.cs       \
49         gc-graystack-stress.cs          \
50         exit-stress.cs          \
51         process-stress.cs       \
52         assembly-load-stress.cs
53
54 # Disabled until ?mcs is fixed
55 #       bug-331958.cs
56 BASE_TEST_CS_SRC=               \
57         bug-2907.cs             \
58         array-init.cs           \
59         arraylist.cs            \
60         assemblyresolve_event.cs        \
61         assemblyresolve_event3.cs       \
62         assemblyresolve_event4.cs       \
63         checked.cs              \
64         char-isnumber.cs        \
65         create-instance.cs      \
66         field-layout.cs         \
67         pack-layout.cs          \
68         pack-bug.cs             \
69         hash-table.cs           \
70         test-ops.cs             \
71         obj.cs                  \
72         test-dup-mp.cs          \
73         string.cs               \
74         stringbuilder.cs        \
75         switch.cs               \
76         outparm.cs              \
77         delegate.cs             \
78         bitconverter.cs         \
79         exception.cs            \
80         exception2.cs           \
81         exception3.cs           \
82         exception4.cs           \
83         exception5.cs           \
84         exception6.cs           \
85         exception7.cs           \
86         exception8.cs           \
87         exception10.cs          \
88         exception11.cs          \
89         exception12.cs          \
90         exception13.cs          \
91         exception14.cs          \
92         exception15.cs          \
93         exception16.cs          \
94         exception17.cs          \
95         exception18.cs          \
96         typeload-unaligned.cs   \
97         struct.cs               \
98         valuetype-gettype.cs    \
99         typeof-ptr.cs           \
100         static-constructor.cs   \
101         pinvoke.cs              \
102         pinvoke2.cs             \
103         pinvoke3.cs             \
104         pinvoke11.cs            \
105         pinvoke13.cs            \
106         pinvoke17.cs            \
107         invoke.cs               \
108         invoke2.cs              \
109         runtime-invoke.cs               \
110         invoke-string-ctors.cs          \
111         reinit.cs               \
112         box.cs                  \
113         array.cs                \
114         enum.cs                 \
115         enum2.cs                \
116         enum-intrins.cs         \
117         property.cs             \
118         enumcast.cs             \
119         assignable-tests.cs     \
120         array-cast.cs           \
121         array-subtype-attr.cs   \
122         cattr-compile.cs        \
123         cattr-field.cs          \
124         cattr-object.cs         \
125         custom-attr.cs          \
126         double-cast.cs          \
127         newobj-valuetype.cs     \
128         arraylist-clone.cs      \
129         setenv.cs               \
130         vtype.cs                \
131         isvaluetype.cs          \
132         iface6.cs               \
133         iface7.cs               \
134         ipaddress.cs            \
135         array-vt.cs             \
136         interface1.cs           \
137         reflection-enum.cs      \
138         reflection-prop.cs      \
139         reflection4.cs          \
140         reflection5.cs          \
141         reflection-const-field.cs \
142         many-locals.cs          \
143         string-compare.cs       \
144         test-prime.cs           \
145         test-tls.cs             \
146         params.cs               \
147         reflection.cs           \
148         interface.cs            \
149         iface.cs                \
150         iface2.cs               \
151         iface3.cs               \
152         iface4.cs               \
153         iface-large.cs          \
154         virtual-method.cs       \
155         intptrcast.cs           \
156         indexer.cs              \
157         stream.cs               \
158         console.cs              \
159         shift.cs                \
160         jit-int.cs              \
161         jit-uint.cs             \
162         jit-long.cs             \
163         long.cs                 \
164         jit-ulong.cs            \
165         jit-float.cs            \
166         pop.cs                  \
167         time.cs                 \
168         appdomain.cs        \
169         appdomain1.cs           \
170         appdomain2.cs           \
171         appdomain-client.cs     \
172         appdomain-unload.cs \
173         appdomain-async-invoke.cs       \
174         loader.cs       \
175         pointer.cs              \
176         hashcode.cs             \
177         delegate1.cs            \
178         delegate2.cs            \
179         delegate3.cs            \
180         delegate5.cs            \
181         delegate6.cs            \
182         delegate7.cs            \
183         delegate8.cs            \
184         delegate9.cs            \
185         delegate10.cs           \
186         delegate11.cs           \
187         remoting1.cs            \
188         remoting2.cs            \
189         remoting3.cs            \
190         remoting4.cs            \
191         remoting5.cs            \
192         largeexp.cs             \
193         largeexp2.cs            \
194         marshalbyref1.cs        \
195         static-ctor.cs          \
196         inctest.cs              \
197         bound.cs                \
198         array-invoke.cs         \
199         test-arr.cs             \
200         decimal.cs              \
201         decimal-array.cs        \
202         marshal.cs              \
203         marshal1.cs             \
204         marshal2.cs             \
205         marshal3.cs             \
206         marshal5.cs             \
207         marshal6.cs             \
208         marshal7.cs             \
209         marshal8.cs             \
210         marshal9.cs             \
211         marshalbool.cs          \
212         marshal-valuetypes.cs   \
213         test-byval-in-struct.cs \
214         thread.cs               \
215         thread5.cs              \
216         thread6.cs              \
217         thread-static.cs        \
218         thread-static-init.cs   \
219         context-static.cs       \
220         float-pop.cs            \
221         interfacecast.cs        \
222         array3.cs               \
223         classinit.cs            \
224         classinit2.cs           \
225         classinit3.cs           \
226         synchronized.cs         \
227         async_read.cs           \
228         threadpool.cs           \
229         threadpool1.cs          \
230         threadpool-exceptions1.cs \
231         threadpool-exceptions2.cs \
232         threadpool-exceptions3.cs \
233         threadpool-exceptions4.cs \
234         threadpool-exceptions5.cs \
235         threadpool-exceptions6.cs \
236         threadpool-exceptions7.cs \
237         base-definition.cs      \
238         bug-27420.cs            \
239         bug-47295.cs            \
240         bug-46781.cs            \
241         bug-48015.cs            \
242         bug-42136.cs            \
243         bug-59286.cs            \
244         bug-70561.cs            \
245         bug-78311.cs            \
246         bug-78653.cs            \
247         bug-78656.cs            \
248         bug-77127.cs            \
249         bug-323114.cs           \
250         bug-Xamarin-5278.cs     \
251         interlocked.cs          \
252         cross-domain.cs         \
253         appdomain-exit.cs       \
254         delegate-async-exit.cs  \
255         delegate-delegate-exit.cs       \
256         delegate-exit.cs        \
257         finalizer-abort.cs      \
258         finalizer-exception.cs  \
259         finalizer-exit.cs       \
260         finalizer-thread.cs     \
261         main-exit.cs    \
262         main-returns-abort-resetabort.cs        \
263         main-returns-background-abort-resetabort.cs     \
264         main-returns-background-resetabort.cs   \
265         main-returns-background.cs      \
266         main-returns-background-change.cs       \
267         main-returns.cs         \
268         subthread-exit.cs       \
269         desweak.cs              \
270         cominterop.cs           \
271         exists.cs               \
272         handleref.cs    \
273         transparentproxy.cs \
274         dbnull-missing.cs       \
275         test-type-ctor.cs       \
276         soft-float-tests.cs     \
277         thread-exit.cs          \
278         finalize-parent.cs      \
279         assemblyresolve_event2.2.cs     \
280         interlocked-2.2.cs      \
281         pinvoke-2.2.cs          \
282         bug-78431.2.cs          \
283         bug-79684.2.cs          \
284         catch-generics.2.cs     \
285         event-get.2.cs          \
286         safehandle.2.cs         \
287         stackframes-async.2.cs          \
288         module-cctor-loader.2.cs        \
289         generics-invoke-byref.2.cs      \
290         generic-signature-compare.2.cs  \
291         generics-sharing.2.cs   \
292         shared-generic-methods.2.cs     \
293         shared-generic-synchronized.2.cs        \
294         generic-inlining.2.cs   \
295         generic-initobj.2.cs    \
296         generic-delegate.2.cs   \
297         generic-sizeof.2.cs     \
298         generic-virtual.2.cs    \
299         generic-interface-methods.2.cs  \
300         generic-array-type.2.cs \
301         generic-method-patching.2.cs    \
302         generic-static-methods.2.cs     \
303         generic-null-call.2.cs  \
304         generic-special.2.cs    \
305         generic-exceptions.2.cs \
306         generic-virtual2.2.cs   \
307         generic-valuetype-interface.2.cs        \
308         generic-getgenericarguments.2.cs        \
309         generic-type-builder.2.cs       \
310         generic-synchronized.2.cs       \
311         generic-delegate-ctor.2.cs      \
312         generic-array-iface-set.2.cs    \
313         generic-typedef.2.cs    \
314         generic-marshalbyref.2.cs       \
315         generic-xdomain.2.cs    \
316         dynamic-generic-size.cs \
317         bug-431413.2.cs \
318         bug-459285.2.cs \
319         generic-virtual-invoke.2.cs     \
320         bug-461198.2.cs \
321         generic-sealed-virtual.2.cs     \
322         generic-system-arrays.2.cs      \
323         generic-stack-traces.2.cs       \
324         generic-stack-traces2.2.cs      \
325         bug-472600.2.cs \
326         recursive-generics.2.cs \
327         bug-473482.2.cs \
328         bug-473999.2.cs \
329         bug-479763.2.cs \
330         bug-616463.cs   \
331         bug-80392.2.cs          \
332         dynamic-method-access.2.cs      \
333         dynamic-method-finalize.2.cs    \
334         bug-82194.2.cs  \
335         anonarray.2.cs  \
336         ienumerator-interfaces.2.cs     \
337         array-enumerator-ifaces.2.cs    \
338         generic_type_definition_encoding.2.cs \
339         generic_type_definition.2.cs    \
340         bug-333798.2.cs         \
341         bug-333798-tb.2.cs              \
342         bug-335131.2.cs         \
343         bug-322722_patch_bx.2.cs                \
344         bug-348522.2.cs         \
345         bug-340662_bug.cs       \
346         bug-322722_dyn_method_throw.2.cs        \
347         bug-389886-2.cs \
348         bug-325283.2.cs \
349         thunks.cs \
350         winx64structs.cs \
351         bug-349190.2.cs \
352         nullable_boxing.2.cs    \
353         valuetype-equals.cs     \
354         custom-modifiers.2.cs   \
355         bug-382986.cs   \
356         test-inline-call-stack.cs       \
357         bug-324535.cs   \
358         modules.cs      \
359         bug-81673.cs    \
360         bug-81691.cs    \
361         bug-80307.cs    \
362         bug-415577.cs   \
363         filter-stack.cs \
364         vararg2.cs      \
365         bug-389886-sre-generic-interface-instances.cs   \
366         bug-461867.cs   \
367         bug-461941.cs   \
368         bug-461261.cs   \
369         bug-400716.cs   \
370         bug-462592.cs   \
371         bug-459094.cs   \
372         generic-unloading.2.cs  \
373         generic-unloading-sub.2.cs      \
374         bug-467456.cs   \
375         appdomain-unload-callback.cs    \
376         bug-508538.cs   \
377         bug-472692.2.cs         \
378         gchandles.cs    \
379         interlocked-3.cs        \
380         interlocked-4.2.cs      \
381         appdomain-thread-abort.cs \
382         xdomain-threads.cs      \
383         w32message.cs   \
384         bug-544446.cs   \
385         gc-altstack.cs  \
386         large-gc-bitmap.cs      \
387         bug-561239.cs   \
388         bug-562150.cs   \
389         bug-575941.cs   \
390         bug-599469.cs   \
391         bug-389886-3.cs \
392         monitor.cs      \
393         monitor-resurrection.cs \
394         dynamic-method-resurrection.cs  \
395         bug-666008.cs   \
396         bug-685908.cs   \
397         sgen-long-vtype.cs      \
398         delegate-invoke.cs      \
399         bug-696593.cs   \
400         bug-705140.cs   \
401         bug-1147.cs     \
402         mono-path.cs    \
403         bug-bxc-795.cs  \
404         bug-3903.cs     \
405         async-with-cb-throws.cs \
406         appdomain-unload-doesnot-raise-pending-events.cs        \
407         bug-6148.cs     \
408         assembly_append_ordering.cs     \
409         bug-10127.cs    \
410         bug-18026.cs    \
411         allow-synchronous-major.cs      \
412         unload-appdomain-on-shutdown.cs \
413         block_guard_restore_aligment_on_exit.cs \
414         thread_static_gc_layout.cs \
415         sleep.cs \
416         bug-27147.cs    \
417         bug-30085.cs    \
418         bug-17537.cs
419
420 TEST_CS_SRC_DIST=       \
421         $(BASE_TEST_CS_SRC)     \
422         async-exc-compilation.cs \
423         filter-stack.cs \
424         finally_guard.cs \
425         finally_block_ending_in_dead_bb.cs
426
427 TEST_CS_SRC_GEN = \
428         runtime-invoke.gen.cs \
429         imt_big_iface_test.cs
430
431 if AMD64
432 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
433 # #651684
434 PLATFORM_DISABLED_TESTS = finally_guard.exe
435 else
436 if X86
437 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
438 else
439 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
440 endif
441 endif
442
443 if IA64
444 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
445 # bug #319249
446 PLATFORM_DISABLED_TESTS=exception17.exe
447 PLATFORM_DISABLED_TESTS+=winx64structs.exe
448 endif
449
450 if X86
451
452 if HOST_WIN32
453 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe finally_block_ending_in_dead_bb.exe \
454         bug-18026.exe monitor.exe threadpool-exceptions5.exe
455 endif
456
457 endif
458
459 if POWERPC
460 # bug #71274
461 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
462 endif
463
464 if POWERPC64
465 # These tests hang
466 PLATFORM_DISABLED_TESTS=monitor.exe finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
467 endif
468
469 if ARM
470 PLATFORM_DISABLED_TESTS=filter-stack.exe
471 endif
472
473 if MIPS
474 # monitor.exe is racy
475 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
476 endif
477
478 if S390X
479 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
480 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
481 endif
482
483 if NACL_CODEGEN
484 # Tests that use Thread.Abort()
485 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
486                          abort-stress-2.exe \
487                          abort-stress-3.exe \
488                          appdomain-thread-abort.exe \
489                          async-exc-compilation.exe \
490                          bug-561239.exe \
491                          bug-70561.exe \
492                          finalizer-abort.exe \
493                          finally_guard.exe \
494                          finally_block_ending_in_dead_bb.exe \
495                          main-returns-abort-resetabort.exe \
496                          main-returns-background-abort-resetabort.exe \
497                          thread6.exe \
498                          threadpool-exceptions5.exe \
499                          threadpool-exceptions6.exe
500
501 # Tests that rely on AppDomain.Unload
502 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
503                           appdomain-exit.exe \
504                           appdomain-unload-callback.exe \
505                           appdomain-unload.exe \
506                           domain-stress.exe \
507                           generic-unloading.2.exe \
508                           monitor.exe \
509                           remoting4.exe \
510                           threadpool-exceptions7.exe \
511                           xdomain-threads.exe
512
513 # pinvoke2 attaches a thread to the runtime, but
514 # doesn't 'unattach' it and it hangs in GC on exit
515 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
516
517 # Tests that currently hang waiting for non-main threads
518 # to exit in NaCl, need to investigate.  Most are AppDomain
519 # creation and Delegate tests.
520 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
521                           delegate9.exe \
522                           marshal-valuetypes.exe \
523                           cross-domain.exe \
524                           stackframes-async.2.exe \
525                           generic-marshalbyref.2.exe \
526                           generic-xdomain.2.exe \
527                           bug-415577.exe
528
529 # Tests that fail trying to write files (appdomain create mostly)
530 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
531                           bug-349190.2.exe \
532                           bug-80307.exe \
533                           bug-462592.exe
534
535 # FIXME: don't know why delegate2.exe fails, it shouldn't
536 PLATFORM_DISABLED_TESTS+= delegate2.exe
537
538 # These tests newly fail with the latest revision. pinvoke3 fails because
539 # of a thread attach, the others have not been investigated.  TODO revisit.
540 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
541                           async_read.exe \
542                           async-with-cb-throws.exe \
543                           appdomain-unload-doesnot-raise-pending-events.exe \
544                           gsharing-valuetype-layout.exe
545
546 if X86
547 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
548 PLATFORM_DISABLED_TESTS+= delegate1.exe \
549                           delegate3.exe \
550                           delegate5.exe \
551                           delegate8.exe \
552                           threadpool.exe \
553                           threadpool1.exe \
554                           threadpool-exceptions3.exe \
555                           bug-323114.exe \
556                           delegate-exit.exe \
557                           bug-80392.2.exe
558
559 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
560 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
561                           main-returns-background.exe \
562                           main-returns-background-change.exe
563 endif
564
565 endif
566
567 # The two finalizer tests only work under sgen
568 # gc-altstack.exe fails under boehm because it has no support for altstack
569 # bug-459094.exe creates an extremely deep directory tree
570 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
571 # reverted.
572 # bug-Xamarin-5278.exe got broken by 5d26590e79da139a284459299aee95c25f4cd835
573 DISABLED_TESTS=                 \
574         delegate-async-exception.exe    \
575         bug-348522.2.exe        \
576         bug-459094.exe \
577         delegate-invoke.exe \
578         bug-Xamarin-5278.exe \
579         $(PLATFORM_DISABLED_TESTS) \
580         $(EXTRA_DISABLED_TESTS)
581
582 DISABLED_TESTS_WRENCH=  \
583         $(DISABLED_TESTS)       \
584         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
585         main-returns-background-resetabort.exe \
586         main-returns-background-abort-resetabort.exe    \
587         thread6.exe     \
588         assemblyresolve_event3.exe \
589         delegate2.exe   \
590         finally_guard.exe \
591         gc-altstack.exe \
592         generic-xdomain.2.exe
593
594 AOT_DISABLED_TESTS=constraints-load.exe
595
596 # These only compile with MS CSC
597 TEST_CSC_SRC=                   \
598         vararg.cs
599
600 TEST_IL_SRC=                    \
601         field-access.il         \
602         method-access.il        \
603         ldftn-access.il         \
604         cpblkTest.il            \
605         vbinterface.il          \
606         calliTest.il            \
607         ckfiniteTest.il         \
608         fault-handler.il                \
609         locallocTest.il         \
610         initblkTest.il          \
611         qt-instance.il          \
612         vararg.il               \
613         bug-29859.il            \
614         bug-78549.il            \
615         static-fields-nonconst.il       \
616         reload-at-bb-end.il     \
617         test-enum-indstoreil.il \
618         filter-bug.il           \
619         even-odd.il             \
620         bug-82022.il    \
621         vt-sync-method.il       \
622         enum_types.il   \
623         invalid-token.il        \
624         call_missing_method.il  \
625         call_missing_class.il   \
626         ldfld_missing_field.il  \
627         ldfld_missing_class.il  \
628         find-method.2.il        \
629         bug-79215.2.il  \
630         bug-79956.2.il  \
631         bug-327438.2.il \
632         bug-387274.2.il \
633         bug-426309.2.il \
634         ldtoken_with_byref_typespec.2.il \
635         resolve_method_bug.2.il \
636         resolve_field_bug.2.il \
637         resolve_type_bug.2.il   \
638         generics-sharing-other-exc.2.il \
639         generic-ldobj.2.il      \
640         generic-mkrefany.2.il   \
641         generic-refanyval.2.il  \
642         generic-ldtoken.2.il    \
643         generic-ldtoken-method.2.il     \
644         generic-ldtoken-field.2.il      \
645         generic-tailcall.2.il   \
646         generic-tailcall2.2.il  \
647         generic-array-exc.2.il  \
648         generic-valuetype-newobj2.2.il  \
649         generic-valuetype-newobj.2.il   \
650         generic-constrained.2.il        \
651         generic-type-load-exception.2.il        \
652         bug-81466.il    \
653         bug457574.il    \
654         bug445361.il    \
655         bug-463303.il   \
656         bug469742.2.il  \
657         bug-528055.il   \
658         constraints-load.il     \
659         array_load_exception.il \
660         bug-481403.il   \
661         interface-with-static-method.il \
662         bug-515884.il   \
663         bug-633291.il   \
664         delegate-with-null-target.il    \
665         bug-318677.il   \
666         gsharing-valuetype-layout.il    \
667         invalid_generic_instantiation.il
668
669
670 # pre-requisite test sources: files that are not test themselves
671 # but that need to be compiled
672 PREREQ_IL_SRC=event-il.il module-cctor.il
673 PREREQ_CS_SRC=
674 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
675 PREREQ_CS_DLL_SRC=
676
677 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
678 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
679 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
680 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
681 TESTBS=$(BENCHSRC:.cs=.exe)
682 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
683
684 EXTRA_DIST=test-driver test-runner.cs $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
685         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
686
687 %.exe: %.il
688         $(ILASM) -out:$@ $<
689
690 %.exe: %.cs TestDriver.dll
691         $(MCS) -r:TestDriver.dll -out:$@ $<
692
693 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
694 if POWERPC
695 test_platform:
696 else
697 # Can't use mkbundle on win32 since there is no static build there
698 # Can't run test-unhandled-exception on Windows because of all the debug popups...
699 if HOST_WIN32
700 test_platform:
701 else
702 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
703 #test_platform: testbundle test-iomap-regression
704 test_platform:  test-iomap-regression
705 endif
706 endif
707
708 if X86
709 if HOST_WIN32
710 else
711 test_platform: test-eglib-remap
712 endif
713 endif
714
715 # Target to precompile the test executables
716 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
717
718 #
719 # Test that no symbols are missed in eglib-remap.h
720 #
721 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file\|g_Ctoc\'
722 if NACL_CODEGEN
723 test-eglib-remap:
724 else
725 test-eglib-remap:
726         @echo "Testing eglib remap..."
727         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
728 endif
729
730 #
731 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
732 # code that checks that the table is properly sorted
733 #
734 if NACL_CODEGEN
735 test-messages:
736 else
737 if HOST_WIN32
738 test-messages:
739 else
740 test-messages: w32message.exe
741         > test_messages.zero
742         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe > w32message.allout 2>&1 && cmp test_messages.zero w32message.allout
743 endif
744 endif
745
746 if AMD64
747 test-sgen : sgen-tests
748 else
749 if X86
750 if HOST_WIN32
751 test-sgen :
752 else
753 test-sgen : sgen-tests
754 endif
755 else
756 if ARM
757 test-sgen : sgen-tests
758 else
759 if S390X
760 test-sgen : sgen-regular-tests
761 endif
762 endif
763 endif
764 endif
765
766 # Precompile the test assemblies in parallel
767 compile-tests:
768         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
769
770 # Remove empty .stdout and .stderr files for wrench
771 rm-empty-logs:
772         @echo "Removing empty logs..."
773         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
774
775 assemblyresolve/test/asm.dll:
776         $(MAKE) -C assemblyresolve prereq
777
778 TestDriver.dll:
779         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
780
781 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
782         @failed=0; \
783         passed=0; \
784         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
785         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
786         for i in $(TESTSI_CS); do       \
787                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
788                 then \
789                         passed=`expr $${passed} + 1`; \
790                 else \
791                         if [ $$? = 2 ]; then break; fi; \
792                         failed=`expr $${failed} + 1`; \
793                 fi \
794         done; \
795         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
796
797 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
798         @failed=0; \
799         passed=0; \
800         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
801         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
802         for i in $(TESTSI_IL); do       \
803                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
804                 then \
805                         passed=`expr $${passed} + 1`; \
806                 else \
807                         if [ $$? = 2 ]; then break; fi; \
808                         failed=`expr $${failed} + 1`; \
809                 fi \
810         done; \
811         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
812
813 testb: $(TEST_PROG) $(TESTBS)
814         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
815         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
816         for i in $(TESTBS); do  \
817                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS);  \
818         done
819
820 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
821         @failed=0; \
822         passed=0; \
823         failed_tests="";\
824         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
825         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
826         rm -f testlist testlist.sorted; \
827         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
828         for i in `cat testlist.sorted`; do \
829                 rm -f $${i}.so; \
830                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
831                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
832                 then \
833                         passed=`expr $${passed} + 1`; \
834                 else \
835                         if [ $$? = 2 ]; then break; fi; \
836                         failed=`expr $${failed} + 1`; \
837                         failed_tests="$${failed_tests} $$i"; \
838                 fi \
839         done; \
840         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
841         rm -f testlist testlist.sorted; \
842         if [ $${failed} != 0 ]; then \
843           echo -e "\nFailed tests:\n"; \
844           for i in $${failed_tests}; do \
845             echo $${i}; \
846             if [ "x$$V" = "x1" ]; then \
847               cat $${i}.stdout; \
848               cat $${i}.stderr; \
849             fi; \
850           done; \
851           exit 1; \
852         fi
853
854 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
855         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
856         $(RUNTIME) ./test-runner.exe -j a --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
857
858 testjit:
859         @if test x$(M) != x0; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
860
861 testaot:
862         @$(MAKE) AOT=1 runtest
863
864 testtrace:
865         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
866
867 testinterp:
868         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
869
870 testjitspeed: $(JITTEST_PROG) $(TESTBS)
871         for i in $(TESTBS); do  \
872                 echo $$i;       \
873                 time $(JITTEST_PROG) $$i;       \
874         done
875
876 test-iomap-regression: exists.cs
877         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
878         @echo "Testing exists.exe..."
879         @MONO_IOMAP=all $(RUNTIME) exists.exe
880
881 stresstest: $(STRESS_TESTS)
882         @failed=0; \
883         passed=0; \
884         failed_tests="";\
885         for i in $(STRESS_TESTS); do    \
886                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
887                 then \
888                         passed=`expr $${passed} + 1`; \
889                 else \
890                         if [ $$? = 2 ]; then break; fi; \
891                         failed=`expr $${failed} + 1`; \
892                         failed_tests="$${failed_tests} $$i"; \
893                 fi \
894         done; \
895         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
896         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
897           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
898
899 testbundle: console.exe
900         @echo "Testing mkbundle..."
901         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
902         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) ./a.out >> mkbundle.stdout
903         @- rm -rf a.out
904
905 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
906 test-type-load: TestDriver.dll
907         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
908         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
909         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
910         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
911         @echo "Testing load-exception.exe..."
912         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
913
914 EXTRA_DIST += custom-attr-errors.cs custom-attr-errors-lib.cs
915 test-cattr-type-load: TestDriver.dll custom-attr-errors.cs custom-attr-errors-lib.cs
916         $(MCS) -D:WITH_MEMBERS /t:library $(srcdir)/custom-attr-errors-lib.cs
917         $(MCS) -r:TestDriver.dll -r:custom-attr-errors-lib.dll  $(srcdir)/custom-attr-errors.cs
918         $(MCS) /t:library $(srcdir)/custom-attr-errors-lib.cs
919         @echo "Testing custom-attribute-load-exceptions.exe..."
920         @$(RUNTIME) custom-attr-errors.exe > custom-attr-errors.exe.stdout 2> custom-attr-errors.exe.stderr
921
922 EXTRA_DIST += reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.cs
923 test-reflection-load-with-context: reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.exe
924         rm -rf reflection-load-dir
925         mkdir reflection-load-dir
926         $(MCS) /t:library $(srcdir)/reflection-load-with-context-second-lib.cs -out:reflection-load-dir/reflection-load-with-context-second-lib.dll
927         $(MCS) /t:library -r:reflection-load-dir/reflection-load-with-context-second-lib.dll $(srcdir)/reflection-load-with-context-lib.cs -out:reflection-load-dir/reflection-load-with-context-lib.dll
928         @echo "Testing reflection-load-with-context.cs.exe..."
929         @$(RUNTIME) reflection-load-with-context.exe > reflection-load-with-context.exe.stdout 2> reflection-load-with-context.exe.stderr
930
931
932 EXTRA_DIST += debug-casts.cs
933 # This depends on TLS, so its not ran by default
934 debug-casts:
935         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
936         @$(RUNTIME) --debug=casts debug-casts.exe
937
938 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs bug-17590.cs sgen-toggleref.cs
939
940
941 #those are actually configurations, eg plain_sgen-descriptors.exe
942 #DISABLE_SGEN_TESTS =
943
944 SGEN_TESTS =    \
945         finalizer-wait.exe      \
946         critical-finalizers.exe \
947         sgen-descriptors.exe    \
948         sgen-gshared-vtype.exe  \
949         sgen-domain-unload.exe  \
950         sgen-weakref-stress.exe \
951         sgen-cementing-stress.exe       \
952         sgen-case-23400.exe     \
953         sgen-new-threads-dont-join-stw.exe      \
954         gc-graystack-stress.exe \
955         bug-17590.exe
956
957 SGEN_CONFIGURATIONS =   \
958         "|plain"        \
959         "major=marksweep-conc|ms-conc"  \
960         "major=marksweep-conc,minor=split|ms-conc-split"        \
961         "minor=split|ms-split"  \
962         "minor=split,alloc-ratio=95|ms-split-95"        \
963         "|plain-clear-at-gc|clear-at-gc"        \
964         "major=marksweep-conc|ms-conc-clear-at-gc|clear-at-gc"  \
965         "minor=split|ms-split-clear-at-gc|clear-at-gc"
966
967
968 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
969 SGEN_BRIDGE_CONFIGURATIONS =    \
970         "|plain"        \
971         ",major=marksweep-conc|ms-conc" \
972         "minor=split|ms-split"  \
973         "bridge-implementation=new|plain-new-bridge"    \
974         "bridge-implementation=new,major=marksweep-conc|ms-conc-new-bridge"     \
975         "bridge-implementation=new,minor=split|ms-split-new-bridge"     \
976         "bridge-implementation=tarjan|plain-tarjan-bridge"      \
977         "bridge-implementation=tarjan,minor=split|ms-split-tarjan-bridge"
978
979 sgen-regular-tests: $(SGEN_TESTS)
980         @failed=0; \
981         passed=0; \
982         failed_tests="";\
983         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
984         for test in $+; do      \
985                 echo "...$$test";       \
986                 for conf in $(SGEN_CONFIGURATIONS); do  \
987                         name=`echo $$conf | cut -d\| -f 2`;     \
988                         params=`echo $$conf | cut -d\| -f 1`;   \
989                         debug_opt=`echo $$conf | cut -d\| -f 3`;        \
990                         test_name="$${test}|$${name}";  \
991                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" MONO_GC_DEBUG="$$debug_opt" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);     \
992                         then \
993                                 passed=`expr $${passed} + 1`; \
994                         else \
995                                 if [ $$? = 2 ]; then break; fi; \
996                                 failed=`expr $${failed} + 1`; \
997                                 failed_tests="$${failed_tests} $$test_name"; \
998                         fi \
999                 done    \
1000         done;   \
1001         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1002         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1003           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1004
1005 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
1006         @failed=0; \
1007         passed=0; \
1008         failed_tests="";\
1009         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1010         for test in $+; do      \
1011                 echo "...$$test";       \
1012                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1013                         name=`echo $$conf | cut -d\| -f 2`;     \
1014                         params=`echo $$conf | cut -d\| -f 1`;   \
1015                         test_name="$${test}|$${name}";  \
1016                         if MONO_GC_DEBUG="bridge=Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS); \
1017                         then \
1018                                 passed=`expr $${passed} + 1`; \
1019                         else \
1020                                 if [ $$? = 2 ]; then break; fi; \
1021                                 failed=`expr $${failed} + 1`; \
1022                                 failed_tests="$${failed_tests} $$test_name"; \
1023                         fi \
1024                 done    \
1025         done;   \
1026         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1027         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1028           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1029
1030 sgen-bridge-tests2: sgen-bridge-xref.exe
1031         @failed=0; \
1032         passed=0; \
1033         failed_tests="";\
1034         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1035         for test in $+; do      \
1036                 echo "...$$test";       \
1037                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1038                         name=`echo $$conf | cut -d\| -f 2`;     \
1039                         params=`echo $$conf | cut -d\| -f 1`;   \
1040                         test_name="$${test}|$${name}";  \
1041                         if MONO_GC_DEBUG="bridge=2Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);        \
1042                         then \
1043                                 passed=`expr $${passed} + 1`; \
1044                         else \
1045                                 if [ $$? = 2 ]; then break; fi; \
1046                                 failed=`expr $${failed} + 1`; \
1047                                 failed_tests="$${failed_tests} $$test_name"; \
1048                         fi \
1049                 done    \
1050         done;   \
1051         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1052         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1053           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1054
1055 sgen-toggleref-tests: sgen-toggleref.exe
1056         @failed=0; \
1057         passed=0; \
1058         failed_tests="";\
1059         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1060         for test in $+; do      \
1061                 echo "...$$test";       \
1062                 for conf in $(SGEN_CONFIGURATIONS); do  \
1063                         name=`echo $$conf | cut -d\| -f 2`;     \
1064                         params=`echo $$conf | cut -d\| -f 1`;   \
1065                         test_name="$${test}|$${name}";  \
1066                         if MONO_GC_PARAMS="toggleref-test,$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);  \
1067                         then \
1068                                 passed=`expr $${passed} + 1`; \
1069                         else \
1070                                 if [ $$? = 2 ]; then break; fi; \
1071                                 failed=`expr $${failed} + 1`; \
1072                                 failed_tests="$${failed_tests} $$test_name"; \
1073                         fi \
1074                 done    \
1075         done;   \
1076         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1077         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1078           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1079
1080 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
1081
1082 sgen-tests: sgen-regular-tests sgen-bridge-tests sgen-toggleref-tests
1083
1084 AOT_CONFIGURATIONS=     \
1085         "|regular"      \
1086         "--gc=boehm|boehm"
1087
1088 #LLVM crashes, got to fix it first.
1089 #       "--llvm|llvm"   \
1090 #       "--llvm --gc=boehm|llvm+boehm"
1091
1092
1093 test-aot:
1094         @failed=0; \
1095         passed=0; \
1096         failed_tests="";\
1097         profile=$(DEFAULT_PROFILE);     \
1098         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1099         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1100         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1101                 asm_name=`basename $$assembly`; \
1102                 echo "... $$asm_name";  \
1103                 for conf in $(AOT_CONFIGURATIONS); do   \
1104                         name=`echo $$conf | cut -d\| -f 2`;     \
1105                         params=`echo $$conf | cut -d\| -f 1`;   \
1106                         test_name="$${asm_name}|$${name}";      \
1107                         echo "  $$test_name";   \
1108                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1109                         then \
1110                                 passed=`expr $${passed} + 1`; \
1111                         else \
1112                                 failed=`expr $${failed} + 1`; \
1113                                 failed_tests="$${failed_tests} $$test_name"; \
1114                         fi \
1115                 done;   \
1116         done;   \
1117         rm      $$tmpfile;      \
1118         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1119         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1120         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1121
1122
1123 # Generated tests for runtime invoke
1124 EXTRA_DIST += gen-runtime-invoke.cs
1125 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1126         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1127         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1128
1129 EXTRA_DIST += make-imt-test.cs
1130 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1131         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1132         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1133
1134 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1135 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1136         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1137 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1138         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1139
1140 EXTRA_DIST += unhandled-exception-base-configuration.config
1141 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1142 EXTRA_DIST += appdomain-unload.exe.config
1143 EXTRA_DIST += unhandled-exception-test-case.2.cs
1144 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1145 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1146         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1147 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1148         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1149 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1150         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1151 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1152         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1153         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1154         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1155         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1156 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1157         $(MCS) /debug unhandled-exception-test-case.1.cs
1158 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1159         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1160 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1161         $(MCS) /debug unhandled-exception-test-case.2.cs
1162 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1163         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1164 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1165         $(MCS) /debug unhandled-exception-test-runner.2.cs
1166
1167 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1168         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1169
1170 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1171 bug-80307.exe: $(srcdir)/bug-80307.cs
1172         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1173         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1174
1175 EXTRA_DIST += bug-81673-interface.cs
1176 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1177         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1178         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1179         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1180
1181 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1182 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1183         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1184         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1185         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1186         rm -f bug-81691-a.dll
1187 bug-81691.exe: bug-81691-b.dll
1188
1189 EXTRA_DIST += bug-81466-lib.il
1190 bug-81466-lib.dll: bug-81466-lib.il
1191         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1192 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1193         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1194
1195 EXTRA_DIST += bug-324535-il.il
1196 bug-324535-il.dll : bug-324535-il.il
1197         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1198 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1199         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1200
1201 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1202 custom-modifiers-lib.dll: custom-modifiers-lib.il
1203         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1204 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1205         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1206
1207 EXTRA_DIST += bug-382986-lib.cs
1208 bug-382986-lib.dll: bug-382986-lib.cs
1209         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1210 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1211         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1212
1213 EXTRA_DIST += bug-17537-helper.cs
1214 bug-17537-helper.exe: bug-17537-helper.cs
1215         $(MCS) -out:$@ $(srcdir)/bug-17537-helper.cs
1216         chmod -x $@
1217
1218 bug-17537.exe: bug-17537.cs bug-17537-helper.exe
1219         $(MCS) -out:$@ $(srcdir)/bug-17537.cs
1220
1221 EXTRA_DIST += coreclr-security.cs
1222
1223 coreclr-security.exe : coreclr-security.cs
1224         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1225
1226 test-coreclr-security : coreclr-security.exe
1227         @echo "Testing coreclr-security.exe..."
1228         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1229
1230 EXTRA_DIST += generic-unboxing.2.il
1231 generic-unboxing.2.dll : generic-unboxing.2.il
1232         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1233
1234 EXTRA_DIST += generic-boxing.2.il
1235 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1236         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1237
1238 EXTRA_DIST += generic-unbox.2.cs
1239 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1240         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1241
1242 EXTRA_DIST += generic-box.2.cs
1243 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1244         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1245
1246 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1247 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1248         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1249 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1250         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1251
1252 bug-3903.exe: bug-3903.cs
1253         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1254
1255 gshared: test-generic-sharing
1256
1257 gshared-aot:
1258         @$(MAKE) AOT=1 gshared
1259
1260 GSHARED_TESTS = \
1261                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1262                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1263                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1264                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1265                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1266                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1267                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1268                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1269                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1270                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1271                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1272                 generic-array-exc.2.exe generic-special.2.exe                   \
1273                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1274                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1275                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1276                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1277                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1278                 generic-constrained.2.exe bug-431413.2.exe                      \
1279                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1280                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1281                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1282                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1283                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1284                 bug-479763.2.exe                                \
1285                 generic-type-load-exception.2.exe bug-616463.exe        \
1286                 bug-1147.exe
1287
1288 test-generic-sharing-normal: $(GSHARED_TESTS)
1289         @for fn in $+ ; do      \
1290                 echo "Testing $$fn ...";        \
1291                 $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;      \
1292                 $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;      \
1293                 $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;      \
1294                 $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;       \
1295                 if [ x$(AOT) = x1 ]; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1296         done
1297
1298 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1299         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1300
1301 if NACL_CODEGEN
1302 test-generic-sharing:
1303 else
1304 test-generic-sharing:
1305         @if test x$(M) != x0; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1306 endif
1307
1308 EXTRA_DIST += async-exceptions.cs
1309 async-exceptions.exe : async-exceptions.cs
1310         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1311 test-async-exceptions : async-exceptions.exe
1312         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1313         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1314
1315 EXTRA_DIST += modules.cs modules-m1.cs
1316 modules-m1.netmodule: modules-m1.cs
1317         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1318 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1319         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1320
1321 # Useful if mono is compiled with --enable-shared=no
1322 patch-libtool:
1323         cp "../../libtool" .
1324         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1325         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1326         touch libtest.c
1327
1328
1329 if NACL_CODEGEN
1330 test-process-exit:
1331 else
1332 EXTRA_DIST += threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1333 test-process-exit:
1334         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1335         @echo "Testing threadpool-in-processexit.exe..."
1336         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1337         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1338 endif
1339
1340 OOM_TESTS =     \
1341         gc-oom-handling.exe     \
1342         gc-oom-handling2.exe
1343
1344
1345 test-oom: $(OOM_TESTS)
1346         @for fn in $+ ; do      \
1347                 echo "Testing $$fn ...";        \
1348                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1349                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1350         done
1351
1352 if HOST_WIN32
1353 test-unhandled-exception-2:
1354 else
1355 test-unhandled-exception-2: unhandled-exception.exe
1356         @echo "Testing unhandled-exception_1 ..."; $(RUNTIME) $+ 1 1> unhandled-exception_1.exe.stdout 2> unhandled-exception_1.exe.stderr; if test "x$$?" != "x1";   then exit 1; fi;  \
1357          echo "Testing unhandled-exception_2 ..."; $(RUNTIME) $+ 2 1> unhandled-exception_2.exe.stdout 2> unhandled-exception_2.exe.stderr; if test "x$$?" != "x0";   then exit 2; fi;  \
1358          echo "Testing unhandled-exception_3 ..."; $(RUNTIME) $+ 3 1> unhandled-exception_3.exe.stdout 2> unhandled-exception_3.exe.stderr; if test "x$$?" != "x0";   then exit 3; fi;  \
1359          echo "Testing unhandled-exception_4 ..."; $(RUNTIME) $+ 4 1> unhandled-exception_4.exe.stdout 2> unhandled-exception_4.exe.stderr; if test "x$$?" != "x0";   then exit 4; fi;  \
1360          echo "Testing unhandled-exception_5 ..."; $(RUNTIME) $+ 5 1> unhandled-exception_5.exe.stdout 2> unhandled-exception_5.exe.stderr; if test "x$$?" != "x255"; then exit 5; fi;  \
1361          echo "Testing unhandled-exception_6 ..."; $(RUNTIME) $+ 6 1> unhandled-exception_6.exe.stdout 2> unhandled-exception_6.exe.stderr; if test "x$$?" != "x0";   then exit 6; fi;  \
1362          echo "Testing unhandled-exception_7 ..."; $(RUNTIME) $+ 7 1> unhandled-exception_7.exe.stdout 2> unhandled-exception_7.exe.stderr; if test "x$$?" != "x0";   then exit 7; fi;  \
1363          echo "Testing unhandled-exception_8 ..."; $(RUNTIME) $+ 8 1> unhandled-exception_8.exe.stdout 2> unhandled-exception_8.exe.stderr; if test "x$$?" != "x3";   then exit 8; fi
1364 endif
1365
1366 noinst_LTLIBRARIES = libtest.la
1367
1368 AM_CPPFLAGS = $(GLIB_CFLAGS)
1369
1370 if HOST_WIN32
1371 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1372 # This shows up when compiling mono_test_marshal_delegate ()
1373 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1374 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1375 # can't find them. So we use --kill-at to remove the @ suffix as well.
1376 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1377 else
1378 libtest_la_LDFLAGS = -rpath `pwd`
1379 endif
1380 libtest_la_SOURCES = libtest.c
1381 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1382
1383 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat